package landlord;

import java.io.PrintStream;
import java.net.URL;
import java.util.ResourceBundle;

import fi.jyu.mit.fxgui.*;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Scene;
import javafx.scene.control.Accordion;
import javafx.scene.control.Button;
import javafx.scene.control.MenuItem;
import javafx.scene.control.TextArea;
import javafx.scene.control.TitledPane;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.Pane;
import javafx.stage.Stage;
import landlordApp.Landlord;
import landlordApp.SailoException;
import landlordApp.Talo;
import landlordApp.Asukas;
import landlordApp.Asunto;

/**
 * @author Nico & Eelis
 * @version 13.3.2020
 *
 */

public class LandlordGUIController implements Initializable {

	  @FXML
	  private ListChooser<Asukas> listResidents;
	  
	  @FXML
	  private TextArea textAreaTalo;

	  @FXML
	  private Button buttonAddResident;

	  @FXML
	  private Button buttonDeleteResident;

	  @FXML
	  private Button buttonResidentInfo;

	  @FXML
	  private MenuItem menuFileNew;

	  @FXML
	  private MenuItem menuFileOpen;

	  @FXML
	  private MenuItem menuFilePrint;

	  @FXML
	  private MenuItem menuFileExit;

	  @FXML
	  private MenuItem menuEditDelete;

	  @FXML
	  private MenuItem menuHelpAbout;

	  @FXML
	  private Button buttonAddApartment;

	  @FXML
	  private Button buttonDeleteApartment;
	  
	  @FXML
	  private Accordion taloAccordion;
	  
	  @Override
	  public void initialize(URL url, ResourceBundle bundle) {
	      //pass
	  }

   /*
	* Luo uuden ns. taloyhtiön.
	*/
    @FXML
    void clickNew(ActionEvent event) {
    	Dialogs.showMessageDialog("Ei toimi.");
    }

    /*
     * Avaa valmiina olevan tiedoston
     */
    @FXML
    void clickOpen(ActionEvent event) {
    	Dialogs.showMessageDialog("Ei toimi.");
    }
    
    /*
     * Tietoja ohjelmasta
     */
    @FXML
    void clickAbout(ActionEvent event) {
    	uusiAsunto();
    }

    /*
     * Avaa uuden ikkunan jossa voi lisätä taloja
     */
    @FXML
    void clickAddApartment(ActionEvent event) {
    	
    	uusiTalo();

    	
    	/*
    	try {
    		FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("LandlordLisaa.fxml"));
    		Pane root = (Pane) fxmlLoader.load();
    		Stage stage = new Stage();
    		stage.setScene(new Scene(root));
    		stage.show();
    	} catch (Exception e) {
    		System.err.println(e.getMessage());
    	}
    	*/
    }

    /*
     * Lisää uuden asukkaan
     */
    @FXML
    void clickAddResident(ActionEvent event) {
        uusiAsukas();
    	//Dialogs.showMessageDialog("Ei toimi.");
    }

    /*
     * Avaa poistoikkunan
     */
    @FXML
    void clickDelete(ActionEvent event) {
    	Dialogs.showMessageDialog("Ei toimi.");
    }

    /*
     * Avaa ikkunan, jossa varmistetaan halutaanko poistaa asunto
     */
    @FXML
    void clickDeleteApartment(ActionEvent event) {
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("LandlordDeleteHousing.fxml"));
            Pane root = (Pane) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root));
            stage.show();
        } catch (Exception e) {
            System.err.println(e.getMessage());
        }
    }

    /*
     * Poistaa valitun asukkaan.
     */
    @FXML
    void clickDeleteResident(ActionEvent event) {
    	Dialogs.showMessageDialog("Ei toimi.");
    }
    
    /*
     * Poistuu sovelluksesta.
     */
    @FXML
    void clickExit(ActionEvent event) {
    	tallenna();
    }
    
    /*
     * Aktivoi napit, kun valitsee jonkun asukkan listasta.
     */
    @FXML
    void clickListResidents(MouseEvent event) {
        buttonResidentInfo.setDisable(false);
        buttonDeleteResident.setDisable(false);
    }

    /*
     * Avaa tulostusikkunan.
     */
    @FXML
    void clickPrint(ActionEvent event) {
    	Dialogs.showMessageDialog("Ei toimi.");
    }

    /*
     * Avaa uuden ikkunan, jossa tiedot valitusta asukkaasta
     */
    @FXML
    void clickResidentInfo(ActionEvent event) {
    	try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("LandlordResidentInfo.fxml"));
            Pane root = (Pane) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root));
            stage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    /*
     * Tallentaa asukkaan tiedot
     */
    @FXML
    void clickResidentInfoOk(ActionEvent event) {
    	Dialogs.showMessageDialog("Ei toimi.");
    }

    /*
     * Peruuttaa muutokset asukkaan tietoihin ja sulkee ikkunan.
     */
    @FXML
    void clickResidentInfoPeruuta(ActionEvent event) {
    	Dialogs.showMessageDialog("Ei toimi.");
    }
    
    
    /*
     * Lisää uuden asunnon
     */
    @FXML
    void clickCreateAppartment(ActionEvent event) {
        Dialogs.showMessageDialog("Ei toimi.");
    }

    /*
     * Lisää uuden talon
     */
    @FXML
    void clickCreateHouse(ActionEvent event) {
        Dialogs.showMessageDialog("Ei toimi.");
    }
    
    /*
     * Peruuttaa muutokset
     */
    @FXML
    void clickCancelDeletion(ActionEvent event) {
        Dialogs.showMessageDialog("Ei toimi.");
    }

    /*
     * Poistaa valitun talon.
     */
    @FXML
    void clickDeleteSelectedHouse(ActionEvent event) {
        Dialogs.showMessageDialog("Ei toimi.");
    }
    
    //====================================================================================
    // Tästä eteenpäin ei käyttöliittymään suoraan liittyviä koodinpätkiä

   private Landlord landlord;
   private TitledPane valittuTaloRuutu; // Valitun talon TitledPane
   private Talo valittuTalo; // Valittu talo-olio.
   private Asunto valittuAsunto; // Valittu asunto-olio.
   private Asukas valittuAsukas; //Valittu asukas-olio.
    
    /**
     * Asetetaan controlleriin landlordviite.
     * @param landlord mihin viitataan
     */
	public void setLandlord(Landlord landlord) {
		this.landlord = landlord;
		listResidents.clear(); //Väliaikainen
	}
	
	
	/**
	 * Lukee tiedostot ja luo käyttöliittymään oliot.
	 * @return virhe
	 */
	public String lueTiedostosta(){
	   
	    try {
	        landlord.lueTiedostosta("./src/data");
	        
	        for(Talo x : landlord.talot) {
	            x.rekisteroi();
	            TitledPane tp = new TitledPane(x.getOsoite() + " " + x.getId(), new ListChooser<Asunto>());
	            taloAccordion.getPanes().add(tp);
	            tp.setOnMouseClicked( e -> naytaTalo(tp));
	            valittuTalo = x;
	            for(Asunto asu :landlord.annaAsunnot(x)){
	            	asu.rekisteroi();
	                @SuppressWarnings("unchecked")
					ListChooser<Asunto> valittu = (ListChooser<Asunto>) tp.getContent(); // Koska valituntaloruudun sisältö ei voi olla muu kuin listchooser
	                valittu.add(asu.getAsuntoId(),asu);
	                valittu.setOnMouseClicked(e -> naytaAsunto(valittu));
	               // valittuAsunto = asu;
	                for (Asukas asukas : landlord.annaAsukkaat(asu)) {
	                	asukas.rekisteroi();
	                }
	            }
	        }
	        
	        return null;
	    }catch(SailoException e) {
	        String virhe = e.getMessage(); 
            if ( virhe != null ) Dialogs.showMessageDialog(virhe);
            return virhe;
	    }
	    
	    
	}
	
	
	/**
	 * Tallentaa muutokset tiedostoihin
	 * @return virhe
	 */
	private String tallenna() {
	    try {
	        landlord.tallenna();
	        return null;
	    }catch(SailoException ex) {
	        Dialogs.showMessageDialog("Tallennuksesssa ongelmia" + ex.getMessage());
	        return ex.getMessage();
	    }
	}
	
	
	/**
	 * Lisää talojen listaan uuden talon ja asettaa lisätyn talon valituksi.
	 */
	private void uusiTalo() {
		Talo uusi = new Talo();
		uusi.rekisteroi();
		uusi.taytaOletus(); //TODO: Korvaa dialogilla

		landlord.lisaa(uusi);

		TitledPane tp = new TitledPane(uusi.getOsoite() + " " + uusi.getId(), new ListChooser<Asunto>());
		taloAccordion.getPanes().add(tp);
		tp.setOnMouseClicked( e -> naytaTalo(tp));
		valittuTalo = uusi;
	}
	
	/**
	 * Lisää asukkaiden listaan uuden asukkaan ja asettaa asukkaan valituksi
	 * @throws SailoException dwawd
	 */
	private void  uusiAsukas(){
	    if(valittuAsunto == null) return; //TODO: error viesti
	    Asukas uusi = new Asukas(valittuAsunto.getId());
	    uusi.rekisteroi();
	    uusi.taytaOletus();
	    landlord.lisaa(uusi);

	    listResidents.add(uusi.getAsukaanEtunimi(), uusi);
	    listResidents.setOnMouseClicked(e -> naytaAsukas(listResidents));
	    valittuAsukas = uusi;
	}
	
	/**
	 * Näyttää ruudulla valitun asukkaan tiedot
	 * @param valittu listchooser, missä asukkaat ovat.Eli siis valitun asunnun lista asukkaista. 
	 */
	private void naytaAsukas(ListChooser<Asukas> listResidents2) {
	    valittuAsukas = listResidents2.getSelectedObject();
        Asukas asukasKohdalla = valittuAsukas;
        
        if (asukasKohdalla == null) return;
        
        
        textAreaTalo.setText("");
        try (PrintStream os = TextAreaOutputStream.getTextPrintStream(textAreaTalo)){
            asukasKohdalla.tulosta(os);
        }
    }

    /**
     * Lisää asuntojen listaan uuden asunnon ja asettaa lisätyn asunnon valituksi.
     */
    private void uusiAsunto() {
        if(valittuTaloRuutu == null) return;
        Asunto uusi = new Asunto(valittuTalo.getId());
        uusi.rekisteroi();
        uusi.taytaOletus(); //TODO: Korvaa dialogilla
        landlord.lisaa(uusi);

        @SuppressWarnings("unchecked")
		ListChooser<Asunto> valittu = (ListChooser<Asunto>) valittuTaloRuutu.getContent(); // Koska valituntaloruudun sisältö ei voi olla muu kuin listchooser
        valittu.add(uusi.getAsuntoId(),uusi);
        valittu.setOnMouseClicked(e -> naytaAsunto(valittu));
        valittuAsunto = uusi;
        
    }

    
	/**
	 * Näyttää ruudulla valitun talon tiedot.
	 * @param valittu valittu titledpane, jossa talon nimi.
	 */
	public void naytaTalo(TitledPane valittu) {
		valittuTaloRuutu = valittu;
		asetaValittuTalo(valittuTaloRuutu.getText());
		Talo taloKohdalla = valittuTalo;
		
		if (taloKohdalla == null) return;
		
		textAreaTalo.setText("");
		try (PrintStream os = TextAreaOutputStream.getTextPrintStream(textAreaTalo)){
			taloKohdalla.tulosta(os);
		}
		
	}
	
   /**
	* Näyttää ruudulla valitun asunnon tiedot.
	* @param valittu valittu listchooser, jossa asunnot ovat. Eli siis valitun talon lista asunnoista
	*/
    public void naytaAsunto(ListChooser<Asunto> valittu) {
        valittuAsunto = valittu.getSelectedObject();
        Asunto asuntoKohdalla = valittuAsunto;
        
        if (asuntoKohdalla == null) return;
        
        listResidents.clear();
        for(Asukas x : landlord.annaAsukkaat(asuntoKohdalla)) {
            listResidents.add(x.getAsukaanEtunimi(),x);
            listResidents.setOnMouseClicked(e -> naytaAsukas(listResidents));
            valittuAsukas = x;
        }
        
        textAreaTalo.setText("");
        try (PrintStream os = TextAreaOutputStream.getTextPrintStream(textAreaTalo)){
            asuntoKohdalla.tulosta(os);
        }
    }
    
  
	/**
	 * Asettaa klikattaessa valituksi taloksi oikean talon etsimällä sen talojen taulukosta.
	 * @param nimi Etsityn talon nimi + id
	 */
	public void asetaValittuTalo(String nimi) {
		for (int i = 0; i < landlord.getTaloja(); i++) {
			if (nimi.equals(landlord.annaTalo(i).getOsoite() + " " + landlord.annaTalo(i).getId())) {
				valittuTalo = landlord.annaTalo(i);
			}
		}
	}
	


}
